// Classe de définition des infos récupérées sur la Box
// c'est une classe de stockage avec uniquement les méthodes de set et de lecture (code dans le .h pour simplifier)
// inutile de la faire dériver de QObject (pas de signaux à trater)

#ifndef LIVEBOXINFOS_H
#define LIVEBOXINFOS_H

#include "qstring.h"
#include <QDateTime>

#define URL_get_MIBs            "/sysbus/NeMo/Intf/data:getMIBs"
#define URL_get_PPP             "/sysbus/NeMo/Intf/data:getMIBs"
#define URL_get_DSL_Stats       "/sysbus/NeMo/Intf/dsl0:getDSLStats"
#define URL_get_WIFI            "/sysbus/NeMo/Intf/lan:getMIBs"
#define URL_get_Device          "/sysbus/DeviceInfo?_restDepth=-1"
#define URL_get_WAN_status      "/sysbus/NMC:getWANStatus"
#define PARAMS_get_MIBs         "{\"parameters\":{\"mibs\":\"dsl\",\"flag\":\"\",\"traverse\":\"down\"}}"
#define PARAMS_get_PPP          "{\"parameters\":{\"mibs\":\"base ppp dhcp\",\"flag\":\"ppp || dhcp\",\"traverse\":\"down\"}}"
#define PARAMS_get_DSL_Stats    "{\"parameters\":{}}"
#define PARAMS_get_Wifi_flags   "{\"parameters\":{\"mibs\":\"wlanvap wlanradio base\",\"flags\":\"wlanvap || wlanradio\",\"traverse\":\"down\"}}"
#define PARAMS_get_WAN_status   "{\"parameters\":{}}"
#define PARAMS_auth_0           "{"service":"sah.Device.Information","method":"createContext","parameters":{"applicationName":"so_sdkut","username":"

class LiveBoxInfos
{
public:
    LiveBoxInfos();
    // Setters
    void setSSID(QString value)                     {mSSID=value;}
    void setDateTime(QString value)                 {mDateTime=value;}
    void setRebootTime(QString value)               {mRebootTime=value;}
    void setSynchroTime(QString value)              {mSynchroTime=value;}
    void setConnectTime(QString value)              {mConnectTime=value;}
    void setIPAddress(QString value)                {mIPAddress=value;}
    void setSofwareVersion(QString value)           {mSoftwareVersion=value;}
    void setHardwareVersion(QString value)          {mHardwareVersion=value;}
    void setNumberOfReboots(double value)           {mNumberOfReboots=value;}
    void setLastChange(double value)                {mLastChange=value;}
    void setLastChangeTime(double value)            {mLastChangeTime=value;}
    void setDownstreamAttenuation(double value)     {mDownstreamAttenuation=value;}
    void setDownstreamLineAttenuation(double value) {mDownstreamLineAttenuation=value;}
    void setDownstreamCurrRate(double value)        {mDownstreamCurrRate=value;}
    void setDownstreamMaxRate(double value)         {mDownstreamMaxRate=value;}
    void setDownstreamNoiseMargin(double value)     {mDownstreamNoiseMargin=value;}
    void setDownstreamPower(double value)           {mDownstreamPower=value;}
    void setUpstreamAttenuation(double value)       {mUpstreamAttenuation=value;}
    void setUpstreamLineAttenuation(double value)   {mUpstreamLineAttenuation=value;}
    void setUpstreamCurrRate(double value)          {mUpstreamCurrRate=value;}
    void setUpstreamMaxRate(double value)           {mUpstreamMaxRate=value;}
    void setUpstreamNoiseMargin(double value)       {mUpstreamNoiseMargin=value;}
    void setUpstreamPower(double value)             {mUpstreamPower=value;}
    void setModulationType(QString value)           {mModulationType=value;}
    void setModulationHint(QString value)           {mModulationHint=value;}
    void setErroredSecs(double value)               {mErroredSecs=value;}
    void setSeverelyErroredSecs(double value)       {mSeverelyErroredSecs=value;}
    void setATUCCRCErrors(double value)             {mATUCCRCErrors=value;}
    void setCRCErrors(double value)                 {mCRCErrors=value;}
    void setATUCFECErrors(double value)             {mATUCFECErrors=value;}
    void setFECErrors(double value)                 {mFECErrors=value;}
    void setATUCHECErrors(double value)             {mATUCHECErrors=value;}
    void setHECErrors(double value)                 {mHECErrors=value;}
    void setCellDelin(double value)                 {mCellDelin=value;}
    void setInitErrors(double value)                {mInitErrors=value;}
    void setInitTimeouts(double value)              {mInitTimeouts=value;}
    void setLinkRetrain(double value)               {mLinkRetrain=value;}
    void setLossOfFraming(double value)             {mLossOfFraming=value;}
    void setReceiveBlocks(double value)             {mReceiveBlocks=value;}
    void setTransmitBlocks(double value)            {mTransmitBlocks=value;}
    void setPppLastChange(double value)             {mPppLastChange=value;}
    void setPppLastChangeTime(double value)         {mPppLastChangeTime=value;}
    void setDNSServer1(QString value)               {mDNSServer1=value;}
    void setDNSServer2(QString value)               {mDNSServer2=value;}
    void setTransportType(QString value)            {mTransportType=value;}
    void setMaxMRUSize(double value)                {mMaxMRUSize=value;}
    // Readers
    QString SSID()                                  {return mSSID;}
    QString DateTime()                              {return mDateTime;}
    QString RebootTime()                            {return mRebootTime;}
    QString SynchroTime()                           {return mSynchroTime;}
    QString ConnectTime()                           {return mConnectTime;}
    QString IPAddress()                             {return mIPAddress;}
    QString SoftwareVersion()                       {return mSoftwareVersion;}
    QString HardwareVersion()                       {return mHardwareVersion;}
    double  NumberOfReboots()                       {return mNumberOfReboots;}
    double  LastChange()                            {return mLastChange;}
    double  LastChangeTime()                        {return mLastChangeTime;}
    double  DownstreamAttenuation()                 {return mDownstreamAttenuation;}
    double  DownstreamLineAttenuation()             {return mDownstreamLineAttenuation;}
    double  DownstreamCurrRate()                    {return mDownstreamCurrRate;}
    double  DownstreamMaxRate()                     {return mDownstreamMaxRate;}
    double  DownstreamNoiseMargin()                 {return mDownstreamNoiseMargin;}
    double  DownstreamPower()                       {return mDownstreamPower;}
    double  UpstreamAttenuation()                   {return mUpstreamAttenuation;}
    double  UpstreamLineAttenuation()               {return mUpstreamLineAttenuation;}
    double  UpstreamCurrRate()                      {return mUpstreamCurrRate;}
    double  UpstreamMaxRate()                       {return mUpstreamMaxRate;}
    double  UpstreamNoiseMargin()                   {return mUpstreamNoiseMargin;}
    double  UpstreamPower()                         {return mUpstreamPower;}
    QString ModulationType()                        {return mModulationType;}
    QString ModulationHint()                        {return mModulationHint;}
    double  ErroredSecs()                           {return mErroredSecs;}
    double  SeverelyErroredSecs()                   {return mSeverelyErroredSecs;}
    double  ATUCCRCErrors()                         {return mATUCCRCErrors;}
    double  CRCErrors()                             {return mCRCErrors;}
    double  ATUCFECErrors()                         {return mATUCFECErrors;}
    double  FECErrors()                             {return mFECErrors;}
    double  ATUCHECErrors()                         {return mATUCHECErrors;}
    double  HECErrors()                             {return mHECErrors;}
    double  CellDelin()                             {return mCellDelin;}
    double  InitErrors()                            {return mInitErrors;}
    double  InitTimeouts()                          {return mInitTimeouts;}
    double  LinkRetrain()                           {return mLinkRetrain;}
    double  LossOfFraming()                         {return mLossOfFraming;}
    double  ReceiveBlocks()                         {return mReceiveBlocks;}
    double  TransmitBlocks()                        {return mTransmitBlocks;}
    double  PppLastChange()                         {return mPppLastChange;}
    double  PppLastChangeTime()                     {return mPppLastChangeTime;}
    QString DNSServer1()                            {return mDNSServer1;}
    QString DNSServer2()                            {return mDNSServer2;}
    QString TransportType()                         {return mTransportType;}
    double  MaxMRUSize()                            {return mMaxMRUSize;}


private:
    QString mSSID;
    QString mDateTime;
    QString mRebootTime;
    QString mSynchroTime;
    QString mConnectTime;
    QString mIPAddress;
    QString mSoftwareVersion;
    QString mHardwareVersion;
    double  mNumberOfReboots;
    // issus de GetMIBs
    double  mLastChange;
    double  mLastChangeTime;
    double  mDownstreamAttenuation;
    double  mDownstreamLineAttenuation;
    double  mDownstreamCurrRate;
    double  mDownstreamMaxRate;
    double  mDownstreamNoiseMargin;
    double  mDownstreamPower;
    double  mUpstreamAttenuation;
    double  mUpstreamLineAttenuation;
    double  mUpstreamCurrRate;
    double  mUpstreamMaxRate;
    double  mUpstreamNoiseMargin;
    double  mUpstreamPower;
    QString mModulationType;
    QString mModulationHint;
    // issus de GetDSLstats
    double  mErroredSecs;
    double  mSeverelyErroredSecs;
    double  mATUCCRCErrors;
    double  mCRCErrors;
    double  mATUCFECErrors;
    double  mFECErrors;
    double  mATUCHECErrors;
    double  mHECErrors;
    double  mCellDelin;
    double  mInitErrors;
    double  mInitTimeouts;
    double  mLinkRetrain;
    double  mLossOfFraming;
    double  mReceiveBlocks;
    double  mTransmitBlocks;
    double  mPppLastChange;
    double  mPppLastChangeTime;
    QString mDNSServer1;
    QString mDNSServer2;
    QString mTransportType;
    double  mMaxMRUSize;
};

#endif // LIVEBOXINFOS_H
