#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QTimer>
#include <QNetworkAccessManager>
#include "graph.h"
#include "accueil.h"
#include "liveboxinfos.h"

#define VERSION "Version 3.01 Développement"
//#define VERSION "Version 3.01 beta 1"

#define CONNEXION 0
#define INTERNET 1
#define QUALITE 2
#define PARAMETRES 3

namespace Ui {
class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();
    void closeEvent(QCloseEvent *);

private slots:
    void RebootLiveBox();
    void LiveBoxGetInfos(LiveBoxInfos *LBinfos);
    void LiveBox4GetInfos(LiveBoxInfos *LBinfos);
    void AppendCSV();
    void CreateCSV();
    void ReadCSV();
    void SaveCSV(QString FileSave);
    void UpDateAffichage();
    void CycleTimerHandler();

    void on_BtnGraphiques_clicked();
    void on_BtnQuitter_clicked();
    void on_checkPass_clicked(bool checked);
    void on_tabWidget_currentChanged();
    void on_timeEditCycle_timeChanged(const QTime &time);
    void on_timeEditDiapo_timeChanged(const QTime &time);
    void on_BtnActualiser_clicked();
    void on_BtnStartAcquisition_clicked();
    void on_BtnStopAcquisition_clicked();
    void on_BtnSaveReleve_clicked();
    void on_BtnRazReleve_clicked();

    void on_editPass_textChanged(const QString &arg1);


    void on_comboExportFormat_currentIndexChanged(const QString &arg1);

    void on_checkDiapoCourbes_toggled(bool checked);

    void on_checkDiapoErreurs_toggled(bool checked);

    void on_BtnRapportGraphique_clicked();

    void on_checkAffDate_toggled(bool checked);

    void on_checkAffHeure_toggled(bool checked);

    void on_checkPortrait_toggled();

    void on_checkPaysage_toggled();

    void on_timeEditArret_timeChanged(const QTime &time);

    void on_btnReboot_clicked();

private:
    Ui::MainWindow *ui;
    Graph          *Graphiques;
    Accueil        *WinAccueil;
    QTimer         *CycleTimer;
    LiveBoxInfos    LBoxInfos;
    LiveBoxInfos    LastInfos;
    QString         LastSyncho;
    double          LastChangeTime;
    double          PppLastChangeTime;
    QString         SessionDateTime;    // date et heure de démarrage du logiciel
    QString         User;               // = admin
    QString         Pass;               // = XXXXXXXX
    QString         SSID;               // Livebox-XXXX
    QString         LiveBox;            // = 192.168.1.1
    char            AlgoType;           // type d'algo à utiliser 0 pour LB2 ou 3 ; 1 pour LB 3 ou 4
    unsigned int    Cycle;              // valeur pour le timer de lecture des infos box
    unsigned int    Diapo;              // valeur pour le timer de diaporama des courbes

    QNetworkAccessManager mgr;          // pour la communication réseau
    bool            IsConnected;
    QString         URLgetMIBs;
    QString         URLgetPPP;
    QString         URLgetDSLStats;
    QString         URLgetWIFI;
    QString         URLgetDevice;
    QString         URLgetWANstatus;
    QByteArray      PARAMSgetMIBs;
    QByteArray      PARAMSgetPPP;
    QByteArray      PARAMSgetDSLStats;
    QByteArray      PARAMSgetWififlags;
    QByteArray      PARAMSgetWANstatus;

};

#endif // MAINWINDOW_H
